EventFrame = CreateFrame("frame", "PetCompare Frame");
myPrefix = "PetComparison121";
MyAddOn_Comms = {};
firstPartyShared = nil; secondPartyShared = nil; thirdPartyShared = nil; fourthPartyShared = nil; petCompareAnswered = false; petCompareScore = 0;

function EventFrame:OnEvent(event, text, ... )
	if(event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_PARTY_LEADER") then
		startedPlayerName = ...;
		text = string.lower(text);
		if(text == "!compare") then
			petCompareScore = 0;
			local myName = UnitName("player") .. "-"..GetNormalizedRealmName();
			print("Starting Pet Comparison Check...");
			if(startedPlayerName == myName) then
				initialized = true;
				myPets = {};
				myRarities = {};
				myLevels = {};
				pointsAddedForPet = {};
				local  numPets, numOwned = C_PetJournal.GetNumPets();
				for firstPlayerCounter = 1, numOwned, 1 do
					petID, speciesID, owned, customName, level, favorite, isRevoked, speciesName, icon, petType, companionID, tooltip, description, isWild, canBattle = C_PetJournal.GetPetInfoByIndex(firstPlayerCounter);

					if(speciesID) then
						local health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(petID);

						if(myPets[speciesID] ~= true) then --if this is the first of a pet
							myPets[speciesID] = true;
							myRarities[speciesID] = rarity;
							myLevels[speciesID] = level;
							pointsAddedForPet[speciesID] = 0.12 * level;
							if(rarity == 2) then --if rarity is common
								pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
							elseif(rarity == 3) then --if rarity is uncommon
								pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
							elseif(rarity == 4) then --if rarity is rare
								pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
							elseif(rarity == 5) then --if rarity is epic
								pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
							elseif(rarity == 6) then --if rarity is legendary
								pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
							end
							petCompareScore = petCompareScore + 2 + pointsAddedForPet[speciesID];

						else --if this is a duplicate
							if(myRarities[speciesID] < rarity) then --if the saved pet was less rare, I need to recalculate
								petCompareScore = petCompareScore - pointsAddedForPet[speciesID];
								pointsAddedForPet[speciesID] = 0.12 * level;
								if(rarity == 2) then --if rarity is common
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
								elseif(rarity == 3) then --if rarity is uncommon
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
								elseif(rarity == 4) then --if rarity is rare
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
								elseif(rarity == 5) then --if rarity is epic
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
								elseif(rarity == 6) then --if rarity is legendary
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
								else
									SendChatMessage("weird rarity happened","party");
								end
								petCompareScore = petCompareScore + pointsAddedForPet[speciesID];
							elseif(myRarities[speciesID] > rarity) then --if the saved pet was more rare
								--do nothing
							else --if the saved pet is as rare as this one
								if(myLevels[speciesID] > level)then --if the saved pet had a higher level
									--do nothing
								elseif(myLevels[speciesID] == level) then --if the saved pet has the same level
									--do nothing
								else -- if the saved pet has a lower level, I need to recalculate
									petCompareScore = petCompareScore - pointsAddedForPet[speciesID];
									pointsAddedForPet[speciesID] = 0.12 * level;
									if(rarity == 2) then --if rarity is common
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
									elseif(rarity == 3) then --if rarity is uncommon
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
									elseif(rarity == 4) then --if rarity is rare
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
									elseif(rarity == 5) then --if rarity is epic
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
									elseif(rarity == 6) then --if rarity is legendary
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
									end
									petCompareScore = petCompareScore + pointsAddedForPet[speciesID];
								end
							end
						end
						
					end
				end

				MyAddOn_Comms:SendAMessage(myPets);

				C_Timer.After(3, function() 
					initialized = false;
				end)

				C_Timer.After(1, function() 
					EventFrame:CreateWindow();
				end)
			end
		end

	elseif(event == "PLAYER_ENTERING_WORLD") then
		EventFrame:onLoad();
	end
end--function

EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
EventFrame:SetScript("OnEvent", EventFrame.OnEvent);


function EventFrame:onLoad()
	firstMatch = true;
	hadAMatch = false;
	initialized = false;
	Serializer=LibStub("LibSerialize");
	Deflater = LibStub("LibDeflate");
	AceGUI = LibStub("AceGUI-3.0");
	AceComm = LibStub:GetLibrary("AceComm-3.0");
	MyAddOn_Comms.Prefix = myPrefix;
	MyAddOn_Comms:Init();
	EventFrame:RegisterEvent("CHAT_MSG_PARTY")
	EventFrame:SetScript("OnEvent", EventFrame.OnEvent);
	EventFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
	EventFrame:SetScript("OnEvent", EventFrame.OnEvent);
	EventFrame:RegisterEvent("CHAT_MSG_ADDON"); -- erase?
	EventFrame:SetScript("OnEvent", EventFrame.OnEvent);
end

function MyAddOn_Comms:Init()
    AceComm:Embed(self);
    self:RegisterComm(self.Prefix, "OnCommReceived");
end

function MyAddOn_Comms:OnCommReceived(passedPrefix, msg, distribution, sender)
	if (passedPrefix == myPrefix) then
		local myName = UnitName("player");
		if(sender ~= myName) then
			if(initialized == true) then
				--SendChatMessage("i started","party");
				local decoded = Deflater:DecodeForWoWAddonChannel(msg)
				if not decoded then return end
				local decompressed = Deflater:DecompressDeflate(decoded)
				if not decompressed then return end
				local success, finalSharedPets = Serializer:Deserialize(decompressed)
				if not success then return end

				totalMembers = GetNumGroupMembers();
				for counter = 1, totalMembers-1, 1 do
					local index = "party" .. counter;
					local name, realm = UnitName(index);
					if(realm) then
						name = name .. "-" .. realm;
					end
					if(name == sender) then --if the sender matches this party members name, 
						if(counter == 1) then
							firstPartyShared = finalSharedPets;
						elseif(counter == 2) then
							secondPartyShared = finalSharedPets;
						elseif(counter == 3) then
							thirdPartyShared = finalSharedPets;
						else
							fourthPartyShared = finalSharedPets;
						end
						break;--get rid of for new bug?
					end
				end

			else
				if(petCompareAnswered == false) then
					--SendChatMessage("i did not start","party");
					petCompareScore = 0;
					local  numPets, numOwned = C_PetJournal.GetNumPets();
					local decoded = Deflater:DecodeForWoWAddonChannel(msg)
					if not decoded then return end
					local decompressed = Deflater:DecompressDeflate(decoded)
					if not decompressed then return end
					local success, theirPets = Serializer:Deserialize(decompressed)
					if not success then return end
					commonPets = {};
					myPets = {};
					myRarities = {};
					myLevels = {};
					pointsAddedForPet = {};
					for secondPlayerCounter = 1, numOwned, 1 do
						petID, speciesID, owned, customName, level, favorite, isRevoked, speciesName, icon, petType, companionID, tooltip = C_PetJournal.GetPetInfoByIndex(secondPlayerCounter);
						if(speciesID) then
							if(theirPets[speciesID] == true) then
								commonPets[speciesID] = true;
							end

							local health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(petID);
							if(myPets[speciesID] ~= true) then --if this is the first of a pet
								myPets[speciesID] = true;
								myRarities[speciesID] = rarity;
								myLevels[speciesID] = level;
								pointsAddedForPet[speciesID] = 0.12 * level;
								if(rarity == 2) then --if rarity is common
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
								elseif(rarity == 3) then --if rarity is uncommon
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
								elseif(rarity == 4) then --if rarity is rare
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
								elseif(rarity == 5) then --if rarity is epic
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
								elseif(rarity == 6) then --if rarity is legendary
									pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
								end
								petCompareScore = petCompareScore + 2 + pointsAddedForPet[speciesID];

							else --if this is a duplicate
								if(myRarities[speciesID] < rarity) then --if the saved pet was less rare, I need to recalculate
									petCompareScore = petCompareScore - pointsAddedForPet[speciesID];
									pointsAddedForPet[speciesID] = 0.12 * level;
									if(rarity == 2) then --if rarity is common
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
									elseif(rarity == 3) then --if rarity is uncommon
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
									elseif(rarity == 4) then --if rarity is rare
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
									elseif(rarity == 5) then --if rarity is epic
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
									elseif(rarity == 6) then --if rarity is legendary
										pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
									end
									petCompareScore = petCompareScore + pointsAddedForPet[speciesID];
								elseif(myRarities[speciesID] > rarity) then --if the saved pet was more rare
									--do nothing
								else --if the saved pet is as rare as this one
									if(myLevels[speciesID] > level)then --if the saved pet had a higher level
										--do nothing
									elseif(myLevels[speciesID] == level) then --if the saved pet has the same level
										--do nothing
									else -- if the saved pet has a lower level, I need to recalculate
										petCompareScore = petCompareScore - pointsAddedForPet[speciesID];
										pointsAddedForPet[speciesID] = 0.12 * level;
										if(rarity == 2) then --if rarity is common
											pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 1;
										elseif(rarity == 3) then --if rarity is uncommon
											pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 2;
										elseif(rarity == 4) then --if rarity is rare
											pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 3;
										elseif(rarity == 5) then --if rarity is epic
											pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 5;
										elseif(rarity == 6) then --if rarity is legendary
											pointsAddedForPet[speciesID] = pointsAddedForPet[speciesID] + 10;
										end
										petCompareScore = petCompareScore + pointsAddedForPet[speciesID];
									end
								end
							end
						end --if speciesName
					end --for loop
					commonPets["score"] = Round(petCompareScore);
					MyAddOn_Comms:SendAMessage(commonPets);
					petCompareAnswered = true;
					C_Timer.After(3, function() 
						petCompareAnswered = false;
					end)
				end
			end
		end --if sender != target
	end--if
end

function MyAddOn_Comms:SendAMessage(myPets)
	local serialized = Serializer:Serialize(myPets); 
	local compressed = Deflater:CompressDeflate(serialized);
	local encoded = Deflater:EncodeForWoWAddonChannel(compressed)
	--SendChatMessage("sending message","party");
	self:SendCommMessage(myPrefix, encoded, "PARTY");
end

function EventFrame:CreateWindow()
	local function DrawGroup1(container)
		scrollcontainer = AceGUI:Create("SimpleGroup");
		scrollcontainer:SetFullWidth(true);
		scrollcontainer:SetFullHeight(true);
		scrollcontainer:SetLayout("Fill");

		container:AddChild(scrollcontainer);

		scroll = AceGUI:Create("ScrollFrame");
		scroll:SetLayout("Flow");
		scrollcontainer:AddChild(scroll);

		local name = UnitName("party1");

		if(firstPartyShared) then
			local scoreLabel = AceGUI:Create("Label");
			scoreLabel:SetText(name .."'s pet score: " .. firstPartyShared["score"] );
			if(petCompareScore > firstPartyShared["score"]) then -- if my score is higher
				scoreLabel:SetColor(0,255,0);
			elseif(petCompareScore == firstPartyShared["score"]) then --if we have the same score
				scoreLabel:SetColor(0,255,42);
			else --if their score is higher
				scoreLabel:SetColor(255,0,0);
			end
			scroll:AddChild(scoreLabel);

			local count = 0;
			for k,v in pairs(firstPartyShared) do
				count = count +1;
			end
			if(count > 1) then
				for k,v in pairs(firstPartyShared) do
					if(k == "score") then
						--do nothing
					else
						speciesName, speciesIcon = C_PetJournal.GetPetInfoBySpeciesID(k)
						local icon = AceGUI:Create("Icon");
						icon:SetImage(speciesIcon);
						icon:SetLabel(speciesName);
						icon:SetImageSize(50,50);
						icon.speciesName = speciesName;

						icon:SetCallback("OnClick",function()
							SetCollectionsJournalShown(true, 2);
							C_PetJournal.SetSearchFilter(icon.speciesName);
							PetJournalListScrollFrameButton1:Click("LeftButton", true);
							C_PetJournal.ClearSearchFilter();
						end)
						scroll:AddChild(icon);
					end	
				end


				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			else
			--SendChatMessage("here","party");
				local PetCompareLabel = AceGUI:Create("Label");
				PetCompareLabel:SetText("You and " .. name .. " have no pets in common.")
				PetCompareLabel:SetFullWidth(true)
				scroll:AddChild(PetCompareLabel);

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			end
		else
			local PetCompareLabel = AceGUI:Create("Label");
			PetCompareLabel:SetText(name .. " does not have the addon so you could not compare.")
			PetCompareLabel:SetFullWidth(true)
			scroll:AddChild(PetCompareLabel);

			local button = AceGUI:Create("Button");
			button:SetText("Tell " .. name .. " that you tried to compare pets");
			button:SetCallback("OnClick", 
			function() 
				SendChatMessage("Hey " .. name .. " I tried to compare pets with you!", "party");
			end)
			button:SetWidth(325);
			scroll:AddChild(button);
		end
	end

	-- function that draws the widgets for the second tab
	local function DrawGroup2(container)
		scrollcontainer = AceGUI:Create("SimpleGroup")
		scrollcontainer:SetFullWidth(true)
		scrollcontainer:SetFullHeight(true)
		scrollcontainer:SetLayout("Fill")

		container:AddChild(scrollcontainer)

		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow") -- probably?
		scrollcontainer:AddChild(scroll)

		local name = UnitName("party2");

		if(secondPartyShared) then
			local scoreLabel = AceGUI:Create("Label");
			scoreLabel:SetText(name.."'s pet score: " .. secondPartyShared["score"] );
			if(petCompareScore > secondPartyShared["score"]) then -- if my score is higher
				scoreLabel:SetColor(0,255,0);
			elseif(petCompareScore == secondPartyShared["score"]) then --if we have the same score
				scoreLabel:SetColor(0,255,42);
			else --if their score is higher
				scoreLabel:SetColor(255,0,0);
			end
			scroll:AddChild(scoreLabel);

			local count = 0;
			for k,v in pairs(secondPartyShared) do
				count = count +1;
			end
			if(count > 1) then
				for k,v in pairs(secondPartyShared) do
					if(k == "score") then
						--do nothing
					else
						speciesName, speciesIcon = C_PetJournal.GetPetInfoBySpeciesID(k)
						local icon = AceGUI:Create("Icon");
						icon:SetImage(speciesIcon);
						icon:SetLabel(speciesName);
						icon:SetImageSize(50,50);
						icon.speciesName = speciesName;

						icon:SetCallback("OnClick",function()
							SetCollectionsJournalShown(true, 2);
							C_PetJournal.SetSearchFilter(icon.speciesName);
							PetJournalListScrollFrameButton1:Click("LeftButton", true);
							C_PetJournal.ClearSearchFilter();
						end)
						scroll:AddChild(icon);
					end
				end	

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			else
				local PetCompareLabel = AceGUI:Create("Label");
				PetCompareLabel:SetText("You and " .. name .. " have no pets in common.")
				PetCompareLabel:SetFullWidth(true)
				scroll:AddChild(PetCompareLabel);

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			end
		else
			local PetCompareLabel = AceGUI:Create("Label");
			PetCompareLabel:SetText(name .. " does not have the addon so you could not compare.")
			PetCompareLabel:SetFullWidth(true)
			scroll:AddChild(PetCompareLabel);

			local button = AceGUI:Create("Button");
			button:SetText("Tell " .. name .. " that you tried to compare pets");
			button:SetCallback("OnClick", 
			function() 
				SendChatMessage("Hey " .. name .. " I tried to compare pets with you!", "party");
			end)
			button:SetWidth(325);
			scroll:AddChild(button);
		end
	end

	-- function that draws the widgets for the second tab
	local function DrawGroup3(container)
		scrollcontainer = AceGUI:Create("SimpleGroup")
		scrollcontainer:SetFullWidth(true)
		scrollcontainer:SetFullHeight(true)
		scrollcontainer:SetLayout("Fill")

		container:AddChild(scrollcontainer)

		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		scrollcontainer:AddChild(scroll)

		local name = UnitName("party3");

		if(thirdPartyShared) then
			local scoreLabel = AceGUI:Create("Label");
			scoreLabel:SetText(name .. "'s pet score: " .. thirdPartyShared["score"] );
			if(petCompareScore > thirdPartyShared["score"]) then -- if my score is higher
				scoreLabel:SetColor(0,255,0);
			elseif(petCompareScore == thirdPartyShared["score"]) then --if we have the same score
				scoreLabel:SetColor(0,255,42);
			else --if their score is higher
				scoreLabel:SetColor(255,0,0);
			end
			scroll:AddChild(scoreLabel);

			local count = 0;
			for k,v in pairs(thirdPartyShared) do
				count = count +1;
			end
			if(count > 1) then
				for k,v in pairs(thirdPartyShared) do 
					if(k == "score") then
						--do nothing
					else
						speciesName, speciesIcon = C_PetJournal.GetPetInfoBySpeciesID(k)
						local icon = AceGUI:Create("Icon");
						icon:SetImage(speciesIcon);
						icon:SetLabel(speciesName);
						icon:SetImageSize(50,50);
						icon.speciesName = speciesName;

						icon:SetCallback("OnClick",function()
							SetCollectionsJournalShown(true, 2);
							C_PetJournal.SetSearchFilter(icon.speciesName);
							PetJournalListScrollFrameButton1:Click("LeftButton", true);
							C_PetJournal.ClearSearchFilter();
						end)
						scroll:AddChild(icon);
					end	
				end	

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			else
				local PetCompareLabel = AceGUI:Create("Label");
				PetCompareLabel:SetText("You and " .. name .. " have no pets in common.")
				PetCompareLabel:SetFullWidth(true)
				scroll:AddChild(PetCompareLabel);

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			end
		else
			local PetCompareLabel = AceGUI:Create("Label");
			PetCompareLabel:SetText(name .. " does not have the addon so you could not compare.")
			PetCompareLabel:SetFullWidth(true)
			scroll:AddChild(PetCompareLabel);

			local button = AceGUI:Create("Button");
			button:SetText("Tell " .. name .. " that you tried to compare pets");
			button:SetCallback("OnClick", 
			function() 
				SendChatMessage("Hey " .. name .. " I tried to compare pets with you!", "party");
			end)
			button:SetWidth(325);
			scroll:AddChild(button);
		end
	end

	-- function that draws the widgets for the second tab
	local function DrawGroup4(container)
		scrollcontainer = AceGUI:Create("SimpleGroup")
		scrollcontainer:SetFullWidth(true)
		scrollcontainer:SetFullHeight(true)
		scrollcontainer:SetLayout("Fill")

		container:AddChild(scrollcontainer)

		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		scrollcontainer:AddChild(scroll)

		local name = UnitName("party4");

		if(fourthPartyShared) then
			local scoreLabel = AceGUI:Create("Label");
			scoreLabel:SetText(name .. "'s pet score: " .. fourthPartyShared["score"] );
			if(petCompareScore > fourthPartyShared["score"]) then -- if my score is higher
				scoreLabel:SetColor(0,255,0);
			elseif(petCompareScore == fourthPartyShared["score"]) then --if we have the same score
				scoreLabel:SetColor(0,255,42);
			else --if their score is higher
				scoreLabel:SetColor(255,0,0);
			end
			scroll:AddChild(scoreLabel);
			local count = 0;
			for k,v in pairs(fourthPartyShared) do
				count = count +1;
			end
			if(count > 1) then
				for k,v in pairs(fourthPartyShared) do 
					if(k == "score") then
						--do nothing
					else
						speciesName, speciesIcon = C_PetJournal.GetPetInfoBySpeciesID(k)
						local icon = AceGUI:Create("Icon");
						icon:SetImage(speciesIcon);
						icon:SetLabel(speciesName);
						icon:SetImageSize(50,50);
						icon.speciesName = speciesName;

						icon:SetCallback("OnClick",function()
							SetCollectionsJournalShown(true, 2);
							C_PetJournal.SetSearchFilter(icon.speciesName);
							PetJournalListScrollFrameButton1:Click("LeftButton", true);
							C_PetJournal.ClearSearchFilter();
						end)
						scroll:AddChild(icon);
					end	
				end	

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			else
				local PetCompareLabel = AceGUI:Create("Label");
				PetCompareLabel:SetText("You and " .. name .. " have no pets in common.")
				PetCompareLabel:SetFullWidth(true)
				scroll:AddChild(PetCompareLabel);

				local button = AceGUI:Create("Button");
				button:SetText("Tell " .. name .. " that you compared pets");
				button:SetCallback("OnClick", 
				function() 
					SendChatMessage("Hey " .. name .. " I compared pets with you!", "party");
				end)
				button:SetWidth(325);
				scroll:AddChild(button);
			end
		else
			local PetCompareLabel = AceGUI:Create("Label");
			PetCompareLabel:SetText(name .. " does not have the addon so you could not compare.")
			PetCompareLabel:SetFullWidth(true)
			scroll:AddChild(PetCompareLabel);

			local button = AceGUI:Create("Button");
			button:SetText("Tell " .. name .. " that you tried to compare pets");
			button:SetCallback("OnClick", 
			function() 
				SendChatMessage("Hey " .. name .. " I tried to compare pets with you!", "party");
			end)
			button:SetWidth(325);
			scroll:AddChild(button);
		end
	end

	-- Callback function for OnGroupSelected
	local function SelectGroup(container, event, group)
	   container:ReleaseChildren()
	   if group == "tab1" then
		  DrawGroup1(container)
	   elseif group == "tab2" then
		  DrawGroup2(container)
	   elseif group == "tab3" then
		  DrawGroup3(container)
	   elseif group == "tab4" then
		  DrawGroup4(container)
	   end
	end

	-- Create the frame container
	local frame = AceGUI:Create("Frame")
	frame:SetTitle("PetCompare")
	frame:SetStatusText("PetCompare created by Van on Stormrage.")
	frame:SetCallback("OnClose", function(widget)
	firstPartyShared = nil; secondPartyShared = nil; thirdPartyShared = nil; fourthPartyShared = nil;
	AceGUI:Release(widget)
	end)
	-- Fill Layout - the TabGroup widget will fill the whole frame
	frame:SetLayout("Fill")

	-- Create the TabGroup
	local tab =  AceGUI:Create("TabGroup");petCompareScore = Round(petCompareScore);
	tab:SetTitle("My pet score: " ..petCompareScore);
	tab:SetLayout("Flow");

	totalMembers = GetNumGroupMembers();

	-- Setup which tabs to show
	if(totalMembers == 2) then
		local party1Name = UnitName("party1");
		tab:SetTabs( { {text=party1Name, value="tab1"} } )

	elseif(totalMembers == 3) then
		local party1Name = UnitName("party1");
		local party2Name = UnitName("party2")
		tab:SetTabs( { {text=party1Name, value="tab1"}, {text=party2Name, value="tab2"} } )

	elseif(totalMembers == 4) then
		local party1Name = UnitName("party1");
		local party2Name = UnitName("party2");
		local party3Name = UnitName("party3");
		tab:SetTabs( { {text=party1Name, value="tab1"}, {text=party2Name, value="tab2"}, {text=party3Name, value="tab3"} } )

	elseif(totalMembers == 5) then
		local party1Name = UnitName("party1");
		local party2Name = UnitName("party2");
		local party3Name = UnitName("party3");
		local party4Name = UnitName("party4");
		tab:SetTabs( { {text=party1Name, value="tab1"}, {text=party2Name, value="tab2"}, {text=party3Name, value="tab3"}, {text=party4Name, value="tab4"} } )
	end

	-- Register callback
	tab:SetCallback("OnGroupSelected", SelectGroup)
	-- Set initial Tab (this will fire the OnGroupSelected callback)
	tab:SelectTab("tab1")

	-- add to the frame container
	frame:AddChild(tab)
end--CreateWindow